[tox]
envlist = py{37,38,39,310,311}-django{32,40,41,42,-latest},qa

[testenv]
usedevelop = True
changedir = {toxinidir}
deps =
    beautifulsoup4
    django-debug-toolbar
    django-requests-debug-toolbar
    importlib_resources<6.0
    git: git+https://gitlab.com/mailman/mailmanclient@master
    git: git+https://gitlab.com/mailman/mailman@master
    git+https://gitlab.com/mailman/django-mailman3.git
    mailman
    mailmanclient
    django-mailman3
    pytest
    pytest-django
    dev: -e../mailmanclient
    dev: -e../django-mailman3
    dev: https://github.com/django/django/archive/main.tar.gz
    django32: django>=3.2,<3.3
    django40: django>=4.0,<4.1
    django41: django>=4.1,<4.2
    django42: django>=4.2,<4.3
    django-latest: https://github.com/django/django/archive/main.tar.gz
commands =
  pytest {posargs:src/}
setenv =
    LC_ALL = C.UTF-8
    LANG = C.UTF-8

[testenv:cov]
basepython = python3
deps =
    {[testenv]deps}
    Django>=3.2,<4.2
    coverage
commands =
    coverage run -m pytest {posargs:src/}
    coverage html
    coverage report -m
setenv =
    LC_ALL = C.UTF-8
    LANG = C.UTF-8

[testenv:qa]
basepython = python3
changedir = {toxinidir}
deps =
    flake8 < 5
    isort
    blue
commands =
    flake8 src/ {posargs}
    isort --check-only src
    blue --check .

[testenv:docs]
deps =
    -r requirements-docs.txt
allowlist_externals =
    mkdir
commands=
    mkdir -p {toxinidir}/src/postorius/doc/_static
    sphinx-build -t html src/postorius/doc build/

[testenv:format]
deps =
    isort
    blue
commands =
    isort .
    blue .

[flake8]
basepython = python3
ignore = E123, E133, W504, W503
show-source = True
exclude = .git,.tox,dist,*egg,src/postorius/doc,example_project


[isort]
line_length=79
# multi_line_output=4
balanced_wrapping=True
known_django=django
sections=FUTURE,STDLIB,DJANGO,THIRDPARTY,FIRSTPARTY,LOCALFOLDER
no_lines_before=LOCALFOLDER
lines_after_imports=2
use_parentheses=True
default_section=THIRDPARTY
known_first_party=postorius
profile=black
skip_gitignore=True
include_trailing_comma = true
indent = '    '

[blue]
extend-exclude =
    src/postorius/migrations/*
